using GMW_data;
using SteamWare;
using System;
using System.Web.UI;

namespace GMW.WebUserControls
{
  public partial class mod_finitiFc : System.Web.UI.UserControl
  {
    /// <summary>
    /// flusso associato (hard coded) a FINITI
    /// </summary>
    protected string flusso = "FI";
    /// <summary>
    /// stato associato (hard coded) a  FINITI
    /// </summary>
    protected string statoUDC = "Fin";
    /// <summary>
    /// attributo per Fuoriciclo
    /// </summary>
    protected string attrFC = "FC";
    /// <summary>
    /// dati x verifica CodSoggetto / matricola
    /// </summary>
    protected string preCodSogg = memLayer.ML.AppConf["prefCodSogg"];
    public event EventHandler eh_reqUpdate;
    /// <summary>
    /// stringa UID univoca
    /// </summary>
    public string uid
    {
      get
      {
        return this.UniqueID.Replace("$", "_").Replace("-", "_");
      }
    }
    /// <summary>
    /// caricamento pagina
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
      if (!Page.IsPostBack)
      {
        Postazione.messaggiText = "";
        Postazione.warningText = "";
        traduciObj();
        checkNumKeyIn();
      }
      doChecks();
    }
    /// <summary>
    /// verifico se ci sia in sessione un input da NumKeyb e nel caso lo metto in barcodeIn e processo...
    /// </summary>
    private void checkNumKeyIn()
    {
      if (memLayer.ML.isInSessionObject("numKeyIn"))
      {
        barcodeIn = memLayer.ML.StringSessionObj("numKeyIn");
        // svuoto valore in sessione...
        memLayer.ML.emptySessionVal("numKeyIn");
        // controllo barcode...
        checkBarcode();
      }
    }
    /// <summary>
    /// richiesta (ri)stampa UDC
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public void ristampa()
    {
      bool fatto = false;
      // registro ri-stampa UDC
      DateTime adesso = DateTime.Now;
      // calcolo particolare...
      DS_magazzino.ElencoCartelliniRow rigaUDC;
      string particolare = "";
      try
      {
        rigaUDC = MagClass.magazzino.taCartellini.getByUdc(udcReq)[0];
        particolare = rigaUDC.Particolare;
        fatto = MagClass.magazzino.ristampaUdc(udcReq, Postazione.printer, Request.UserHostName);
      }
      catch
      {
        logger.lg.scriviLog(string.Format("Errore recupero particolare UDC Finiti {0}", udcReq), tipoLog.EXCEPTION);
      }
      if (fatto) MagClass.magazzino.taSAO.insertQuery(adesso, MagClass.magazzino.CodSoggCurrUser, Postazione.name, Postazione.IP, udcReq, particolare, "stampaUDC", "Ri-Stampato UDC Finiti Mult");
      doUpdate();
    }
    /// <summary>
    /// udc da stampare
    /// </summary>
    protected string udcReq
    {
      get
      {
        return memLayer.ML.StringSessionObj("udcSelSAO");
      }
    }
    /// <summary>
    /// controlla particolare selezionato
    /// </summary>
    private void checkParticolare()
    {
      if (currParticolare != "")
      {
        lblParticolareAttivo.Text = string.Format("Particolare selezionato <b>{0}</b>", currParticolare);
        lblPart.Text = currParticolare;
        // aggiungo descrizione del particolare
        string descr = "";
        string disegno = "";
        try
        {
          DS_magazzino.AnagParticolariRow riga = MagClass.magazzino.taAnagPart.likeSearch(currParticolare, memLayer.ML.StringSessionObj("CodCS"))[0];
          descr = riga.DescParticolare;
          disegno = string.Format("( {0} )", riga.DisegnoGrezzo);
        }
        catch
        { }
        lblDescrAttivo.Text = descr;
        lblDisegno.Text = disegno;
      }
      else
      {
        lblParticolareAttivo.Text = "...";
        lblDescrAttivo.Text = "";
        lblDisegno.Text = "";
      }
    }
    /// <summary>
    /// effettua controlli visibilità
    /// </summary>
    private void doChecks()
    {
      checkBarcode();
      checkStampa();
      checkParticolare();
    }
    /// <summary>
    /// sistemo labels oggetti
    /// </summary>
    private void traduciObj()
    {
      //txtBox
      qtaUDC = memLayer.ML.cdvi("QtaImballoFiniti");
      numUDC = 1;
      refreshQta();
      // buttons
      btnEmptyNote.Text = traduci("btnEmptyNote");
    }
    /// <summary>
    /// restituisce il nome della pagina corrente
    /// </summary>
    protected string PagCorrente
    {
      get
      {
        string answ = "";
        Uri MyUrl = Request.Url;
        string delimStr = "/";
        char[] delimiter = delimStr.ToCharArray();
        string[] finalUrl = MyUrl.LocalPath.ToString().Split(delimiter);
        int n = finalUrl.Length;
        answ = finalUrl[n - 1].ToString();
        DataLayer_AnagGen.PermessiRow riga = (DataLayer_AnagGen.PermessiRow)user_std.UtSn.permessi.Select(string.Format("URL = '{0}'", answ))[0];
        answ = riga.NOME;
        return answ;
      }
    }
    /// <summary>
    /// wrapper traduzione
    /// </summary>
    /// <param name="lemma"></param>
    /// <returns></returns>
    public string traduci(object lemma)
    {
      return user_std.UtSn.Traduci(lemma.ToString());
    }

    /// <summary>
    /// indica il codice articolo correntemente selezionato
    /// </summary>
    protected string currParticolare
    {
      get
      {
        return memLayer.ML.StringSessionObj(string.Format("currParticolare_{0}", uid));
      }
      set
      {
        memLayer.ML.setSessionVal(string.Format("currParticolare_{0}", uid), value, memLayer.ML.confReadBool("keepParticolareSel"));
      }
    }
    /// <summary>
    /// indica se i caratteri vadano forzati a maiuscoli
    /// </summary>
    public bool forceUppercase
    {
      get
      {
        return memLayer.ML.confReadBool("forceUppercase");
      }
    }
    /// <summary>
    ///  num pezzi dell'ultimo UDC del particolare generato
    /// </summary>
    public int pezziUdc
    {
      get
      {
        int answ = 0;
        try
        {
          answ = (int)MagClass.magazzino.taCartellini.getLastByParticolareStato(memLayer.ML.StringSessionObj("CodCS"), currParticolare, statoUDC, false)[0].Qta;
        }
        catch
        { }
        return answ;
      }
    }
    /// <summary>
    /// cod imballo dell'ultimo UDC del particolare generato
    /// </summary>
    public string lastCodImb
    {
      get
      {
        string answ = "";
        try
        {
          answ = MagClass.magazzino.taCartellini.getLastByParticolareStato(memLayer.ML.StringSessionObj("CodCS"), currParticolare, statoUDC, false)[0].CodImballo;
        }
        catch
        { }
        return answ;
      }
    }
    /// <summary>
    /// decodifica il tipo barcode acquisito
    /// </summary>
    public tipoCodiceBarcode tipoBCode
    {
      get
      {
        tipoCodiceBarcode answ = tipoCodiceBarcode.ND;
        int trovati = 0;
        int matricola = -1;
        // provo a convertire in intero barcode x verifica eventuale matricola...
        try
        {
          matricola = Convert.ToInt32(barcodeIn);
        }
        catch
        { }
        // controllo non si tratti di un comando...
        string preCmd = memLayer.ML.AppConf["prefComandi"];
        if (barcodeIn.StartsWith(preCmd))
        {
          answ = tipoCodiceBarcode.Comando;
        }
        // controllo se sia un finito Tipo P
        else if (TermClass.Ter.riconosciBarcode(barcodeIn) == tipoCodiceBarcode.Particolare && TermClass.Ter.isParticolare(barcodeIn)) // è un particolare...
        {
          answ = tipoCodiceBarcode.Particolare;
        }
        // controllo se sia un codice IMBALLO
        else if (utils.obj.taSelImballi.getByImballo(barcodeIn).Rows.Count > 0)
        {
          // è imballo!
          answ = tipoCodiceBarcode.Imballo;
        }
        else if (barcodeIn.StartsWith(preCodSogg))
        {
          // cerco cod soggetto...
          if (DataProxy.obj.taTrascSogg.getByKey(barcodeIn, 0).Rows.Count == 1)
          {
            answ = tipoCodiceBarcode.Operatore;
          }
        }
        else if (matricola >= 0)
        {
          if (DataProxy.obj.taTrascSogg.getByKey("", matricola).Rows.Count == 1)
          {
            answ = tipoCodiceBarcode.Operatore;
          }
        }
        else
        {
          try
          {
            // cerco tra gitterbox (UDC)...
            trovati = MagClass.magazzino.taCartellini.getByUdc(barcodeIn).Rows.Count;
            if (trovati > 0)
            {
              answ = tipoCodiceBarcode.UDC;
            }
          }
          catch
          {
          }
        }
        return answ;
      }
    }
    /// <summary>
    /// valore barcode
    /// </summary>
    public string barcodeIn
    {
      get
      {
        return txtBarcode.Text.Trim();
      }
      set
      {
        txtBarcode.Text = value;
      }
    }
    /// <summary>
    /// qta pezzi TOTALE
    /// </summary>
    public int qta
    {
      set
      {
        txtQta.Text = value.ToString();
      }
    }
    /// <summary>
    /// qta pezzi x UDC
    /// </summary>
    public int qtaUDC
    {
      get
      {
        int _qtaUDC = 0;
        if (txtQtaUDC.Text.Trim() != "")
        {
          try
          {
            _qtaUDC = Convert.ToInt32(txtQtaUDC.Text.Trim());
          }
          catch
          { }
        }
        return _qtaUDC;
      }
      set
      {
        txtQtaUDC.Text = value.ToString();
        refreshQta();
      }
    }
    /// <summary>
    /// num UDC
    /// </summary>
    public int numUDC
    {
      get
      {
        int numUDC = 0;
        if (txtNumUDC.Text.Trim() != "")
        {
          try
          {
            numUDC = Convert.ToInt32(txtNumUDC.Text.Trim());
          }
          catch
          { }
        }
        return numUDC;
      }
      set
      {
        txtNumUDC.Text = value.ToString();
        refreshQta();
      }
    }
    /// <summary>
    /// controlla se ci sia un barcode
    /// </summary>
    private void checkBarcode()
    {
      if (barcodeIn != "")
      {
        Postazione.messaggiText = string.Format("Barcode digitato: {0}", barcodeIn);
        switch (tipoBCode)
        {
          case tipoCodiceBarcode.Comando:
            if (barcodeIn == memLayer.ML.cdv("cmdReset"))
            {
              currParticolare = "";
              Response.Redirect(PagCorrente);
            }
            break;
          case tipoCodiceBarcode.Imballo:
            // cerco di selezionare!
            try
            {
              ddlImballi.SelectedValue = barcodeIn;
            }
            catch
            {
              Postazione.warningText = traduci("ERR-IMB-001");
              Postazione.CssClass = "stileComandoKo";
            }
            break;
          case tipoCodiceBarcode.Particolare:
            // imposto il particolare corrente
            currParticolare = barcodeIn;
            // controllo esista il particolare scansionato
            if (DataProxy.obj.taAnagParticolari.getByParticolare(currParticolare).Rows.Count == 0)
            {
              currParticolare = "";
              Postazione.messaggiText += traduci("ERR-FIN-001");
              Postazione.CssClass = "stileComandoKo";
            }
            else
            {
              Postazione.messaggiText += traduci("partSelected");
              Postazione.CssClass = "stileComandoOk";
            }
            // leggo la qta dell'ultimo UDC del particolare, SE C'E', e la imposto...
            if (pezziUdc > 0)
            {
              qtaUDC = pezziUdc;
            }
            else // rimette default
            {
              qtaUDC = memLayer.ML.cdvi("QtaImballoFiniti");
            }
            if (lastCodImb != "")
            {
              selezionaImballo();
            }
            break;
          case tipoCodiceBarcode.UDC:
            // procedo solo se UDC esistente
            if (MagClass.magazzino.checkUDC(barcodeIn))
            {
              // recupero il particolare dai dati del cartellino preesistente
              currParticolare = DataProxy.obj.taCartellini.stp_getByUdc(barcodeIn)[0].Particolare;
              // controllo esista!!!
              bool partExists = DataProxy.obj.taAnagParticolari.getByParticolare(currParticolare).Rows.Count != 0;
              // controllo sia anima!!!
              bool isPart = TermClass.Ter.isParticolare(currParticolare);
              // controllo esista il particolare e sia anima
              if (partExists && isPart)
              {
                Postazione.messaggiText += traduci("partSelected");
                Postazione.CssClass = "stileComandoOk";
              }
              else
              {
                currParticolare = "";
                Postazione.messaggiText += traduci("ERR-FIN-001");
                Postazione.CssClass = "stileComandoKo";
              }
            }
            break;
          case tipoCodiceBarcode.Operatore:
            // calcolo matricola utente
            int MatrUtente = -1;
            string preCodSogg = memLayer.ML.AppConf["prefCodSogg"];
            if (barcodeIn.StartsWith(preCodSogg))
            {
              MatrUtente = DataProxy.obj.taTrascSogg.getByKey(barcodeIn, 0)[0].CodMatricola;
            }
            else
            {
              MatrUtente = Convert.ToInt32(barcodeIn);
            }
            if (MatrUtente >= 0)
            {
              // salvo in sessione operatore con AUTH
              OpAuth.startOpAuth(MatrUtente);
              // mostro che ho autorizzato...
              Postazione.messaggiText += traduci("userAuthRec");
              Postazione.CssClass = "stileComandoOk";
              currParticolare = "";
              qta = 0;
              Response.Redirect(user_std.pagCorrente);
            }
            else
            {
              Postazione.messaggiText += traduci("ERR-BCD-001");
              Postazione.CssClass = "stileComandoND";
            }
            break;
          default:
            // cerco se sia "0" = reset utente...
            if (barcodeIn == memLayer.ML.CRS("resetCodSogg"))
            {
              // salvo in sessione operatore con AUTH
              OpAuth.stopAuth();
              // mostro che ho autorizzato...
              Postazione.messaggiText += traduci("userAuthRem");
              Postazione.CssClass = "stileComandoOk";
              Response.Redirect(user_std.pagCorrente);
            }
            Postazione.messaggiText += traduci("ERR-BCD-001");
            Postazione.CssClass = "stileComandoND";
            break;
        }
        barcodeIn = "";
      }
#if false
            else
            {
                Postazione.messaggiText = traduci("AttesaBCode");
                Postazione.CssClass = "stileAttesa";
            } 
#endif
      doUpdate();
    }
    /// <summary>
    /// aggiorna tabella + focus a barcode
    /// </summary>
    public void doUpdate()
    {
      updatePart();
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
      checkStampa();
      txtBarcode.Focus();
    }
    /// <summary>
    /// aggiorna visualizzazioen dati particolare
    /// </summary>
    private void updatePart()
    {
      if (currParticolare != "")
      {
        lblParticolareAttivo.Text = string.Format("{0} <b>{1}</b>", traduci("particSel"), currParticolare);
        // aggiungo descrizione del particolare
        string descr = "";
        string disegno = "";
        try
        {
          DS_magazzino.AnagParticolariRow riga = MagClass.magazzino.taAnagPart.likeSearch(currParticolare, memLayer.ML.StringSessionObj("CodCS"))[0];
          descr = riga.DescParticolare;
          disegno = string.Format("( {0} )", riga.DisegnoGrezzo);
        }
        catch
        { }
        lblDescrAttivo.Text = descr;
        lblDisegno.Text = disegno;
      }
      else
      {
        lblParticolareAttivo.Text = "...";
        lblDescrAttivo.Text = "";
        lblDisegno.Text = "";
      }
    }
    /// <summary>
    /// controllo l'abilitazione alla stampa UDC:
    /// - particolare ok
    /// - qtaUDC > 0
    /// - almeno 1 UDC
    /// altrimenti disabilito btn stampa
    /// </summary>
    private void checkStampa()
    {
      bool stampaOk = false;
      //controllo siano inseriti valori qta
      if (qtaUDC > 0 && numUDC > 0)
      {
        // controllo ci siano particolare e qta tornino (numUdc x qtaUdc = qtaTOT)
        if (currParticolare != "")
        {
          // 2018.10.31 NON PERMETTO STAMPA se ho "- MAT.VAR.IMBAL"
          bool imballoOk = (ddlImballi.SelectedValue != "" && ddlImballi.SelectedValue != "- MAT.VAR.IMBAL");
          if (imballoOk)
          {
            stampaOk = true;
          }
        }
      }
      divNote.Visible = stampaOk;
    }
    /// <summary>
    /// genera i barcode di
    /// - trattamenti
    /// - nuovo x pezzi liquidi
    /// e lancia la relativa stampa
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbtStampaUDC_Click(object sender, EventArgs e)
    {
      bool needsRedirect = false;
      // verifico postazione x procedere...
      if (Postazione.printer != "n.d.")
      {
        // verifico auth utente OPPURE se NON sia richiesta...
        if (OpAuth.isAuth || !OpAuth.opAuthReq)
        {
          string newUdcChild = "";
          string noteTrim = string.Format("{0}{1}{2}", traduci("fuoriciclo"), Environment.NewLine, txtNote.Text.Trim());
          // effettuo controlli che cod_soggetto e cod particolare siano disponibili...
          string codSogg = "";
          string particolare = "";
          try
          {
            codSogg = MagClass.magazzino.CodSoggCurrUser;
            particolare = currParticolare;
          }
          catch
          {
          }
          if (codSogg != "" && particolare != "")
          {
            for (int i = 0; i < numUDC; i++)
            {
              // genero cartellino liquidi
              DateTime adesso = DateTime.Now;
              try
              {
                string codImballo = "";
                try
                {
                  codImballo = ddlImballi.SelectedValue;
                }
                catch
                {
                  codImballo = memLayer.ML.cdv("CodImballoFiniti");
                }
                // se NON HA selezionato prendo default...
                if (string.IsNullOrEmpty(codImballo) || codImballo == "-")
                {
                  codImballo = memLayer.ML.cdv("CodImballoFiniti");
                }
                // creo nuovo UDC del trattamento liquidi
                newUdcChild = MagClass.magazzino.creaUdc(flusso, "", currParticolare, "", "", "", "", "", 0, codImballo, "U", codSogg, qtaUDC, 0, 0, adesso, 0, statoUDC, memLayer.ML.cdvi("IdxPosizioneFiniti"), "IdxPosizioneFiniti", "UDC_FINITO", noteTrim, "", adesso.Year, Request.UserHostName);

                if (OpAuth.isAuth)
                {
                  // salvo attributo dell'OpAuth...
                  MagClass.magazzino.taAtt2UDC.Insert(newUdcChild, memLayer.ML.CRS("attrOpAuth"), OpAuth.currAuth.CodSoggetto, DateTime.Now, codSogg);
                }

                // registro creazione nuovo UDC
                MagClass.magazzino.taSAO.insertQuery(adesso, codSogg, Postazione.name, Postazione.IP, newUdcChild, particolare, "creaUDC", string.Format("Creato nuovo UDC Finiti, qta: {0} {1}", qtaUDC, noteTrim));
                // inserisco attributo fuoriciclo
                MagClass.magazzino.taAtt2UDC.Insert(newUdcChild, attrFC, "", DateTime.Now, codSogg);
              }
              catch (Exception exc)
              {
                httpLog(string.Format("Errore creazione UDC finiti: {0}", exc), tipoLog.EXCEPTION);
              }
              // se ho cart stampo!
              if (newUdcChild != "")
              {
                // ora stampo il nuovo cartellino!!!
                MagClass.magazzino.stampaUdc(newUdcChild, Postazione.printer, tipoCartellino.cartFiniti, Request.UserHostName);
                // incremento timing...
                adesso = DateTime.Now;
                adesso = adesso.AddSeconds(1);
                // registro stampa nuovo UDC
                MagClass.magazzino.taSAO.insertQuery(adesso, codSogg, Postazione.name, Postazione.IP, newUdcChild, particolare, "stampaUDC", "Stampato UDC Finiti");
              }
            }
            // consumo una auth...
            OpAuth.currAuth.remAuth--;
            if (OpAuth.currAuth.remAuth == 0)
            {
              OpAuth.stopAuth();
              needsRedirect = true;
            }
            // resetto
            doResetData();
          }
          else
          {
            httpLog(string.Format("FINITI, Errore persi utente/particolare, ricarico!"), tipoLog.ERROR);
            Response.Redirect("~/login.aspx");
          }
        }
        else
        {
          Postazione.messaggiText = traduci("noOpAuth");
          Postazione.CssClass = "stileComandoKo";
          httpLog(string.Format("Errore manca OpAuth x UDC anime"), tipoLog.ERROR);
        }
      }
      else
      {
        Response.Redirect("~/menu.aspx");
      }
      doUpdate();
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
      if (needsRedirect)
      {
        Response.Redirect(user_std.pagCorrente);
      }
    }
    /// <summary>
    /// wrapper per log con salvataggio dell'IP del chiamante
    /// </summary>
    /// <param name="_testoPre"></param>
    /// <returns></returns>
    public bool httpLog(string _testoPre)
    {
      bool answ = false;
      logger.lg.scriviLog(Postazione.IP + _testoPre);
      return answ;
    }
    /// <summary>
    /// wrapper per log con salvataggio dell'IP del chiamante
    /// </summary>
    /// <param name="_testoPre"></param>
    /// <returns></returns>
    public bool httpLog(string testoLog, tipoLog tipo)
    {
      bool answ = false;
      logger.lg.scriviLog(Postazione.IP + testoLog, tipo);
      return answ;
    }
    /// <summary>
    /// effettua reset dati
    /// </summary>
    private void doResetData()
    {
      // resetto i dati QtaUdc, numUdc, QtaTot e particolare...
      qtaUDC = 0;
      numUDC = 1;
      refreshQta();
      currParticolare = "";
      doChecks();
    }
    /// <summary>
    /// svuoto le note
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnEmptyNote_Click(object sender, EventArgs e)
    {
      txtNote.Text = "";
      Postazione.messaggiText = traduci("AttesaBCode");
      Postazione.CssClass = "stileAttesa";
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
    }
    /// <summary>
    /// aggiornata qta UDC: aggiorno totale!
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void txtQtaUDC_TextChanged(object sender, EventArgs e)
    {
      refreshQta();
    }
    /// <summary>
    /// aggiorna qta totale
    /// </summary>
    private void refreshQta()
    {
      qta = qtaUDC * numUDC;
    }
    /// <summary>
    /// aggiornato num UDC: aggiorno totale!
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void txtNumUDC_TextChanged(object sender, EventArgs e)
    {
      refreshQta();
    }
    /// <summary>
    /// preseleziono (se possibile) imballo...
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ddlImballi_DataBound(object sender, EventArgs e)
    {
      selezionaImballo();
    }
    /// <summary>
    /// seleziona imballo corretto
    /// </summary>
    private void selezionaImballo()
    {
      string codImb = "";
      // cerco se c'è un imballo x particolare corrente...
      if (currParticolare != "")
      {
        codImb = lastCodImb;
      }
      else
      {
        codImb = memLayer.ML.cdv("CodImballoFiniti");
      }
      try
      {
        // preseleziono
        ddlImballi.SelectedValue = codImb;
      }
      catch
      { }
    }

    protected void ddlImballi_SelectedIndexChanged(object sender, EventArgs e)
    {

    }
  }
}